<?php
require_once("Binary.php");

if(isset($_REQUEST['str'])) $str = $_REQUEST['str'];
else $str = "あ";

//$code = array('SJIS','EUC-JP','UTF-8','ISO-8859-1');
//$code = array('SJIS-WIN','EUC-JP','UTF-8', 'ISO-2022-JP');
$code = array('SJIS-WIN','EUC-JP','UTF-8','UHC');
$base_code = $code[2];

foreach($code as $c)
  $convert[$c] = mb_convert_encoding($str, $c, $base_code);


?><!DOCTYPE html>
<html lang="ja">
 <head>
  <meta charset="<?php print $base_code;?>">
  <link rel="stylesheet" type="text/css" href="base.css">
  <title>文字をコンピュータがどう認識しているか確認しよう</title>
 </head>
 <body>
<h2>ある文字が，文字コードごとにどんなビット列に対応するか</h2>
<hr>
 <form method="post" action="">
  (<?=htmlspecialchars($base_code)?>)
  <input type="text" name="str" value="<?=htmlspecialchars($str)?>" class="code">
  <input type="submit" name="button" value="Convert"> (1文字ずつ入力するのをおすすめします) <br>
 </form>
<hr>
<table border="1">
 <tr>
  <th>コード</th>
  <th>文字</th>
  <th>ビット列(2進表現)</th>
  <th>ビット列(16進表現)</th>
 </tr>
<?php foreach($code as $c){ ?>
  <tr>
   <th><?=$c?></th>
   <td><?=htmlspecialchars($convert[$c])?></td>
   <td><b>
	<a href="bitToChar.php?base=2&bitstring=<?=convertHexToBinary(bin2hex($convert[$c]))?>">
	<?=convertHexToBinary(bin2hex($convert[$c]))?>
	</a>
   </b></td>
   <td><b>
	<a href="bitToChar.php?base=16&bitstring=<?=bin2hex($convert[$c])?>">
	<?=bin2hex($convert[$c])?>
	</a>
   </b></td>
  </tr>
<?php } ?>
</table>

SJIS-WIN: Shift-JISをMicrosoftが拡張したもの (つまり，同じShift-JISの中ですら微妙に文字コードの扱いが違うものが複数あるということ・・・)
  
 </body>
</html>

